use std::env;

pub async fn establish_connection() -> sea_orm::DatabaseConnection {
    let database_url = env::var("DATABASE_URL").expect("DATABASE_URL must be set");
    let db = sea_orm::Database::connect(&database_url).await;
    db.unwrap_or_else(|_| panic!("Error connecting to {}", database_url))
}
